﻿package packages {
	
	import flash.display.Loader;
	
	public class Image extends Loader {
		
		import flash.events.MouseEvent;
		import flash.events.Event;
		import flash.net.URLRequest;
		
		import flash.display.LoaderInfo;
		import flash.events.ProgressEvent;
		import flash.text.TextField;
		import flash.text.TextFieldAutoSize;
		import flash.text.TextFormat;
		
		import packages.Globals;
		
		var ImageWidth:Number;
		var ImageHeight:Number;
		
		var OrigX:Number;
		var OrigY:Number;
		var OffsetX:Number;
		var OffsetY:Number;
		
		var loadProgress_txt:TextField = new TextField();
		
		//CONSTRUCTOR:
		public function Image(url:String, locked:Boolean = false) {
			var ImageUrl:URLRequest = new URLRequest(url);
			load(ImageUrl);
			if (locked == false) {
				addEventListener(MouseEvent.MOUSE_OVER, ImageOver);
				addEventListener(MouseEvent.MOUSE_OUT, ImageOut);
				addEventListener(MouseEvent.MOUSE_DOWN, ImageStartDrag);
				addEventListener(MouseEvent.MOUSE_UP, ImageReturn);
			} else {
				mouseEnabled = false;
			}
			contentLoaderInfo.addEventListener(Event.OPEN, showPreloader);
			contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, showProgress);
			contentLoaderInfo.addEventListener(Event.COMPLETE, showLoadResult);
		}
		
		//EVENTS:
		private function ImageOver(event:MouseEvent):void { alpha = Globals.ALPHA_VALUE; }
		private function ImageOut(event:MouseEvent):void  { alpha = 1; }

		private function ImageStartDrag(event:MouseEvent):void {
			OrigX = x;
			OrigY = y;
			OffsetX = event.stageX - x;
			OffsetY = event.stageY - y;
			addEventListener(MouseEvent.MOUSE_MOVE, ImageDrag);
		}
		
		private function ImageDrag(event:MouseEvent):void {
			x = event.stageX - OffsetX;
			y = event.stageY - OffsetY;
			addEventListener(MouseEvent.MOUSE_OUT, ImageReturn);
			event.updateAfterEvent();
		}
		
		private function ImageReturn(event:MouseEvent):void {
			removeEventListener(MouseEvent.MOUSE_MOVE, ImageDrag);
			removeEventListener(MouseEvent.MOUSE_OUT, ImageReturn);
			x = OrigX;
			y = OrigY;
		}
		
		private function ResizeImage(event:Event):void {
			width = ImageWidth;
			height = ImageHeight;
			contentLoaderInfo.removeEventListener(Event.INIT, ResizeImage);
		}
		
		function showPreloader(event:Event):void {
			parent.addChild(loadProgress_txt);
			loadProgress_txt.autoSize = TextFieldAutoSize.LEFT;
			loadProgress_txt.background = true;
            loadProgress_txt.border = true;
			loadProgress_txt.x = x;
			loadProgress_txt.y = y;
			var format:TextFormat = new TextFormat();
            format.font = "Verdana";
            format.color = 0xFF0000;
            format.size = 10;
            format.bold = true;
            loadProgress_txt.defaultTextFormat = format;
		}
		
		function showProgress(event:ProgressEvent):void {
			var percent:Number = Math.round((event.bytesLoaded / event.bytesTotal ) * 100 );
			loadProgress_txt.text = percent + "%";
		}
		
		function showLoadResult(event:Event):void {
			parent.removeChild(loadProgress_txt);
		}
		
		//ACCESSORS:
		public function GetWidth():Number  { return ImageWidth; }
		public function GetHeight():Number { return ImageHeight; }
		public function GetImage():Loader  { return this; }
		
		//MUTATORS:
		public function SetCoords(X:Number, Y:Number):void { 
			x = X;
			y = Y;
		}
		
		public function SetSize(W:Number, H:Number):void { 
			ImageWidth = W;
			ImageHeight = H;
			contentLoaderInfo.addEventListener(Event.INIT, ResizeImage);
		}
	}
}