﻿package packages {
	
	import flash.display.Sprite;
	
	public class Style extends Sprite {
		
		import flash.events.MouseEvent;
		
		import packages.Globals;
		
		var StyleWidth:Number;
		var StyleHeight:Number = Globals.THUMB_HEIGHT;
		
		var OrigX:Number;
		var OrigY:Number;
		var OffsetX:Number;
		var OffsetY:Number;
		var dragging:Boolean;
		
		//CONSTRUCTOR:
		public function Style(xml:XML) {
			StyleWidth = StyleHeight * Globals.PAGE_WIDTH_MM / Globals.PAGE_HEIGHT_MM;
			graphics.lineStyle(1, 0x000000);
			graphics.beginFill(0xc0c0c0);
			graphics.drawRect(0, 0, StyleWidth, StyleHeight);
			var elemXML:XML;
			for each (elemXML in xml.PICTURE) {
				graphics.lineStyle(1, 0x000000);
				graphics.beginFill(0xe0e0e0);
				graphics.drawRect((Number(elemXML.@LEFT) + Globals.PAGE_MARGIN_TW) * StyleWidth / Globals.PAGE_WIDTH_TW, Number(elemXML.@TOP) * StyleHeight / Globals.PAGE_HEIGHT_TW, Number(elemXML.@WIDTH) * StyleWidth / Globals.PAGE_WIDTH_TW, Number(elemXML.@HEIGHT) * StyleHeight / Globals.PAGE_HEIGHT_TW);
			}
			for each (elemXML in xml.TEXT) {
				graphics.lineStyle(1, 0x000000);
				graphics.beginFill(0xffffff);
				graphics.drawRect((Number(elemXML.@LEFT) + Globals.PAGE_MARGIN_TW) * StyleWidth / Globals.PAGE_WIDTH_TW, Number(elemXML.@TOP) * StyleHeight / Globals.PAGE_HEIGHT_TW, Number(elemXML.@WIDTH) * StyleWidth / Globals.PAGE_WIDTH_TW, Number(elemXML.@HEIGHT) * StyleHeight / Globals.PAGE_HEIGHT_TW);
			}
			buttonMode = true;
			addEventListener(MouseEvent.MOUSE_OVER, StyleOver);
			addEventListener(MouseEvent.MOUSE_OUT, StyleOut);
			addEventListener(MouseEvent.MOUSE_DOWN, StyleStartDrag);
			addEventListener(MouseEvent.MOUSE_UP, StyleReturn);
		}
		
		//EVENTS:
		private function StyleOver(event:MouseEvent):void { alpha = Globals.ALPHA_VALUE; }
		private function StyleOut(event:MouseEvent):void  { alpha = 1; }
		
		private function StyleStartDrag(event:MouseEvent):void {
			dragging = true;
			OrigX = x;
			OrigY = y;
			OffsetX = event.stageX - x;
			OffsetY = event.stageY - y;
			addEventListener(MouseEvent.MOUSE_MOVE, StyleDrag);
		}
		
		private function StyleDrag(event:MouseEvent):void {
			x = event.stageX - OffsetX;
			y = event.stageY - OffsetY;
			addEventListener(MouseEvent.MOUSE_OUT, StyleReturn);
			event.updateAfterEvent();
		}
		
		private function StyleReturn(event:MouseEvent):void {
			if (dragging == true) {
				removeEventListener(MouseEvent.MOUSE_MOVE, StyleDrag);
				removeEventListener(MouseEvent.MOUSE_OUT, StyleReturn);
				x = OrigX;
				y = OrigY;
				dragging = false;
			}
		}
		
		//ACCESSORS:
		public function GetWidth():Number  { return StyleWidth; }
		public function GetHeight():Number { return StyleHeight; }
		public function GetStyle():Style   { return this; }
		
		//MUTATOR:
		public function SetCoords(X:Number, Y:Number):void { 
			x = X;
			y = Y;
		}
	}
}